#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

struct drvo{
 int broj, balans;
 struct drvo *levi, *desni;
};

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))

int dodaj(struct drvo **, int );
void lrotacija(struct drvo **);
void drotacija(struct drvo **);
int dubina(struct drvo *);
void ispis(struct drvo *);

void sredi(struct drvo **);
int nadji(struct drvo **);

int dodaj(struct drvo **p, int k){
 struct drvo *t=*p;
 int inkrement, rezultat;
 rezultat=0;
 if(t==NULL){
  novi(t);
  if(!t) exit(0);
  t->broj=k;
  t->levi=t->desni=NULL;
  t->balans=0;
  rezultat=1;
 }
 else{
  if(k>t->broj) inkrement=dodaj(&(t->desni),k);
  else inkrement=-dodaj(&(t->levi),k);
  t->balans+=inkrement;
  if(inkrement!=0 && t->balans!=0){
   if(t->balans<-1){
    if(t->levi->balans<0) drotacija(&t);
    else{ lrotacija(&(t->levi)); drotacija(&t);}
   }
   if(t->balans>1){
    if(t->desni->balans>0) lrotacija(&t);
    else{ drotacija(&(t->desni)); lrotacija(&t);}
   }
  }
  else rezultat=1;
 }
 *p=t;
 return rezultat;
}

void lrotacija(struct drvo **p){
 struct drvo *poml, *pomd;
 poml=*p;
 pomd=poml->desni;
 poml->desni=pomd->levi;
 pomd->levi=poml;
 *p=pomd;
 poml->balans=dubina(poml->desni)-dubina(poml->levi);
 pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct drvo **p){
 struct drvo *poml, *pomd;
 pomd=*p;
 poml=pomd->levi;
 pomd->levi=poml->desni;
 poml->desni=pomd;
 *p=poml;
 poml->balans=dubina(poml->desni)-dubina(poml->levi);
 pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dubina(struct drvo *p){
 int dd=0, dl=0;
 if(p){
  if(p->levi) dl=dubina(p->levi); 
  if(p->desni) dd=dubina(p->desni);
  if(dl>dd) return ++dl;
  else return ++dd;
 }
}

struct drvo *form(){
 struct drvo *p; 
 int k, i, n;
 p=NULL;
 printf("Ucitaj br. elemenata stabla:");
 scanf("%d\n",&n);
 for(i=0;i<n;i++){
  scanf("%d",&k);
  dodaj(&p,k);
 }
 return p;
}

void sredi(struct drvo **p){
 struct drvo *pom;
 if(*p){
 pom=*p;
  if(pom->balans<-1){
    if(pom->levi->balans<0) drotacija(&pom);
    else{ lrotacija(&(pom->levi)); drotacija(&pom);}
   }
   if(pom->balans>1){
    if(pom->desni->balans>0) lrotacija(&pom);
    else{ drotacija(&(pom->desni)); lrotacija(&pom);}
   }
*p=pom;  
}
  
  
}


int nadji(struct drvo **p){
 struct drvo *pom;
 int rez;
 pom=*p;
 if(!pom->levi){
  rez=pom->broj;
  pom=pom->desni;
}
 else rez=nadji(&(pom->levi));
 if(pom){
  pom->balans=dubina(pom->desni)-dubina(pom->levi);
  sredi(&pom);
  return pom;
 }
}

void brisi(struct drvo **p, int k){
 struct drvo *pom;
 if(p->broj==k){
  if((!p->levi)&&(!p->desni)){
   free(p);
   return NULL;
  }
  if((!p->levi)&&(p->desni)){
   pom=p->desni;
   free (p);
   return pom;
  }
  if((p->levi)&&(!p->desni)){
  pom=p->levi;
  free(p);
  return pom;
  }
  if((p->levi)&&(p->desni)){
   pom->broj=nadji(&(p->levi));
   p->balans=dubina(p->desni)-dubina(p->levi);
   sredi(&p);
   return p;
  }
 }
 
}

void ispis(struct drvo *p){
 if(p){
  ispis(p->levi);
  printf("%d\t",p->broj);
  /*printf("balans: %d\n",p->balans);*/
  ispis(p->desni);
 }
 
}

main(){
 struct drvo *p;
 p=form(); 
 int k;
 ispis(p);
 /*printf("Unesi br. k:");
 scanf("%d\n",&k);
 brisi(&p,k)
 ispis(p);*/
}

