#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct skladiste{
  char *naziv, *lokacija;
  int bz; /* broj zaposlenih */
  int kapacitet;
};

struct lista{
  struct skladiste *podaci;
  struct lista *rep;
};

struct skladiste *ucitaj(void){
  struct skladiste *t;
  char s[20];
  
  t=(struct skaldiste *)malloc(sizeof(struct skladiste));
  if(!t) exit(0);
  
  scanf("%s",s);
  t->naziv=(char *)malloc(strlen(s)+1);
  if(!t->naziv) exit(0);
  strcpy(t->naziv,s);
  
  scanf("%s",s);
  t->lokacija=(char *)malloc(strlen(s)+1);
  if(!t->lokacija) exit(0);
  strcpy(t->lokacija,s);
  
  scanf("%d",&t->bz);
  scanf("%d",&t->kapacitet);
  
  return t;
}

void dodaj(struct lista **p, struct skalidiste *t){
  struct lista *tmp;
  tmp=(struct lista *)malloc(sizeof(struct lista));
  if(!tmp) exit(0);
  tmp->podaci=t;
  tmp->rep=*p;
  *p=tmp;
}

struct lista *form(void){
  struct lista *p=NULL;
  struct skladiste *t;
  int i,n;
  scanf("%d",&n);
  for(i=0; i<n; i++){
    t=ucitaj();
    dodaj(&p,t);
  }
  return p;
}

void ispis(struct lista *p){
  while(p){
    printf("%s\t%s\t%d\t%d\n",p->podaci->naziv,p->podaci->lokacija,p->podaci->bz,p->podaci->kapacitet);
    p=p->rep;
  }
}

int suma(struct lista *p, int x){
  int s=0;
  while(p){
    if(p->podaci->kapacitet>x) s+=p->podaci->bz;
    p=p->rep;
  }
  return s;
}

struct lista *izbaci(struct lista *p, char m[20]){
  struct lista *res=p, *pos, *temp;
  pos=res;
  while(pos && !(strcmp(pos->podaci->naziv,m))){
    res=pos->rep;
    free(pos);
    pos=res;
  }
  while(pos  && pos->rep)
    if(!strcmp(pos->rep->podaci->naziv,m)){
      temp=pos->rep;
      pos->rep=temp->rep;
      free(temp);
    }
    else pos=pos->rep;
  return res;
}

main(){
  struct lista *p=NULL;
  int x,s=0;
  char m[20];
  p=form();
  ispis(p);
  printf("Granicnik za sumu je: ");
  scanf("%d",&x);
  printf("Brij zaposlenih u takvim skladistima je %d\n",s=suma(p,x));
  printf("Unesite lokaciju: ");
  scanf("%s",m);
  p=izbaci(p,m);
  ispis(p);
}