#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct predavac
{
	char *ime,*zvanje;
	int bp,rs;
};
struct lista
{
	struct predavac *prof;
	struct lista *link;
};

#define novi(x) x=(struct predavac*)malloc(sizeof(struct predavac))
#define nova(x) x=(struct lista*)malloc(sizeof(struct lista))

void dodaj(struct lista **, struct predavac *);
struct predavac *form(void);
void ispis(struct lista *);
struct predavac *ucitaj(void);

struct predavac *ucitaj(void)
{
	char s[20];
	struct predavac *temp;
	novi(temp);
	if(!temp) exit(0);
	
	printf("Ime : \n");
	scanf("%s",s);
	temp->ime=(char *)malloc(strlen(s)+1);
	if(!temp->ime) exit(0);
	strcpy(temp->ime,s);
	
	printf("Zvanje \n");
	scanf("%s",s);
	temp->zvanje=(char *)malloc(strlen(s)+1);
	if(!temp->ime) exit(0);
	strcpy(temp->zvanje,s);
		
	printf("Broj predmeta :\n");
	scanf("%d",&temp->bp);
	
	printf("Radni staz :\n");
	scanf("%d",&temp->rs);	
	
	printf("\n\n");
	return temp;
}

void dodaj(struct lista **p, struct predavac *t)
{	
	struct lista *tmp,*pom1,*pom2;
	pom1=(*p);
	
	nova(tmp);
	if(!tmp) { printf("Greska pri alociranju memorije\n"); exit(0);}
	
	tmp->prof=t;
	
	if(pom1==NULL) {pom1=tmp;tmp->link=NULL;printf("*** kreira glavu ***\n");}
	else
		if(t->bp < pom1->prof->bp)
		{
			printf("*** pre glave ***\n");
			tmp->link=pom1;
			pom1=tmp;
		}
	else
	{
		printf("*** u sredini ***\n");
		pom2=pom1;
		while ((pom2->link)&&(pom2->link->prof->bp > tmp->prof->bp))
		{pom2=pom2->link;
		printf("while  ");
		}
		tmp->link = pom2->link;
		pom2->link = tmp;		
	}
	
	(*p)=pom1;
}

int max(struct lista *p)
{
	char zp[20];
	int k;
	
	printf("Unesi zvanje : \n");
	scanf("%s",zp);

	while (p->link)
	{
		if (strcmp(zp,p->prof->zvanje)==0) k=p->prof->rs;
	}
}
	

struct predavac *form()
{
	struct lista *p;
	struct predavac *kol;
	int n,i;
	
	p=NULL;
	
	printf("Unesi broj clanova\n");
	scanf("%d",&n);
	
	printf("Unosi redom clanove:\n");
	
	kol=ucitaj();
	
	for(i=1;i<n;i++)
	{
		dodaj(&p,kol);
		kol=ucitaj();
	}
return p;
}

void ispis(struct lista *p)
{
	if(p)
	{
		printf("\n\n\n");
		printf("Ime\t\tZvanje\t\tBr.Pred.\tRadni Staz\n");
		while(p->link)
		{
			printf("%s\t\t",p->prof->ime);
			printf("%s\t\t",p->prof->zvanje);
			printf("%d\t\t",p->prof->bp);
			printf("%d\t\n",p->prof->rs);
			p=p->link;
		}
		printf("\n");
	}
	else printf("Lista je prazna");
}
	
main()
{
	struct predavac *p;
	
	p=form();
	ispis(p);
}

