#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct lista
{
	struct lista *sled;
	char *naziv,*lokacija;
	int broj_zap,kapacitet;
};

void dodaj_sort(struct lista **l,char naziv[30],char lokacija[30],int broj_zap,int kapacitet);
void ispis(struct lista *l);
void form(struct lista **l);
int jednak(struct lista *l,char k[30]);
void brisi(struct lista **l,int k);


main()
{
	struct lista *l=NULL;
	char k[30];
	int n;
	form(&l);
	ispis(l);
	printf("unesi lokaciju k\n");
	scanf("%s",k);
	printf("broj lokacija %s je %d\n",k,jednak(l,k));
	printf("unesi broj za brisanje\n");
	scanf("%d",&n);
	brisi(&l,n);
	ispis(l);
}

void dodaj_sort(struct lista **l,char naziv[30],char lokacija[30],int broj_zap,int kapacitet)
{
	struct lista *pom=NULL,*pom1=*l;
	if(pom1==NULL)
	{
		pom=(struct lista *)malloc(sizeof(struct lista));
		pom->naziv=(char *)malloc(strlen(naziv)+1);
		strcpy(pom->naziv,naziv);
		pom->lokacija=(char *)malloc(strlen(lokacija)+1);
		strcpy(pom->lokacija,lokacija);
		pom->broj_zap=broj_zap;
		pom->kapacitet=kapacitet;
		pom->sled=NULL;
	}
	else
	{
		if(pom1->kapacitet>kapacitet)
		{
			pom=(struct lista *)malloc(sizeof(struct lista));
			pom->naziv=(char *)malloc(strlen(naziv)+1);
			strcpy(pom->naziv,naziv);
			pom->lokacija=(char *)malloc(strlen(lokacija)+1);
			strcpy(pom->lokacija,lokacija);
			pom->broj_zap=broj_zap;
			pom->kapacitet=kapacitet;
			pom->sled=*l;
			*l=pom;
		}
		else
		{
			while(pom1->sled && pom1->sled->kapacitet<kapacitet) pom1=pom1->sled;
			pom=(struct lista *)malloc(sizeof(struct lista));
			pom->naziv=(char *)malloc(strlen(naziv)+1);
			strcpy(pom->naziv,naziv);
			pom->lokacija=(char *)malloc(strlen(lokacija)+1);
			strcpy(pom->lokacija,lokacija);
			pom->broj_zap=broj_zap;
			pom->kapacitet=kapacitet;
			pom->sled=pom1->sled;
			pom1->sled=pom;
		}
	}
}

void ispis(struct lista *l)
{
	while(l)
	{
		printf("%s\t",l->naziv);
		printf("%s\t",l->lokacija);
		printf("%d\t",l->broj_zap);
		printf("%d\t\n",l->kapacitet);
	}
}

void form(struct lista **l)
{
	int i,n,broj_zap,kapacitet;
	char naziv[30],lokacija[30];
	printf("koliko skladista zelis da uneses?\n");
	scanf("%d",&n);
	printf("unesi skladista\n");
	for(i=0;i<n;i++)
	{
		printf("skladiste %d\n",i);
		scanf("%s",naziv);
		scanf("%s",lokacija);
		scanf("%d",&broj_zap);
		scanf("%d",&kapacitet);
		dodaj_sort(l,naziv,lokacija,broj_zap,kapacitet);
	}
	printf("\n");
}

int jednak(struct lista *l,char k[30])
{
	int i=0;
	while(l)
	{
		if(strcmp(l->lokacija,k)==0) i++;
		l=l->sled;
	}
}

void brisi(struct lista **l,int k)
{
	struct lista *pom=*l,*pom1=*l;
	while(pom)
	{
		if(pom->broj_zap>k)
		{
			if(pom==*l)
			{
				pom=pom->sled;
				*l=pom1=pom;
			}
			else
			{
				pom1->sled=pom->sled;
				free(pom);
				pom=pom1->sled;		
			}
		}
	}
}

