#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct stablo
{
	struct stablo *levi,*desni;
	int balans;
	char *string;
};

void lrotacija(struct stablo **st);
void drotacija(struct stablo **st);
int dodaj(struct stablo **l,char string[30]);
int dubina(struct stablo *st);
void ispis(struct stablo *st);

main()
{
	int i,n;
	struct stablo *st;
	char string[30];
	printf("unesi broj n\n");
	scanf("%d",&n);
	printf("unesi clanove stabla\n");
	for(i=0;i<n;i++)
	{
		scanf("%s",string);
		dodaj(&st,string);
	}
	ispis(st);
	
}

void lrotacija(struct stablo **st)
{
	struct stablo *poml,*pomd;
	poml=*st;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*st=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct stablo **st)
{
	struct stablo *poml,*pomd;
	pomd=*st;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*st=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(struct stablo **l,char string[30])
{
	int inkrement,rezultat=0;
	struct stablo *pom=*l;
	if(pom==NULL)
	{
		pom=(struct stablo *)malloc(sizeof(struct stablo));
		pom->levi=pom->desni=NULL;
		pom->string=(char *)malloc(strlen(string)+1);
		strcpy(pom->string,string);
		rezultat=1;
	}
	else
	{
		if(strcmp(pom->string,string)>0) inkrement=-dodaj(&(pom->levi),string);
		else inkrement=dodaj(&(pom->desni),string);
		pom->balans=pom->balans+inkrement;
		if(inkrement!=0 && pom->balans!=0)
		{
			if(pom->balans<-1)
			{
				if(pom->levi->balans<0)
				{
					drotacija(&pom);
				}
				else
				{
					lrotacija(&(pom->levi));
					drotacija(&pom);
				}
			}
			else if(pom->balans>1)
			{
				if(pom->desni->balans>0)
				{
					lrotacija(&pom);
				}
				else
				{
					drotacija(&(pom->desni));
					lrotacija(&pom);
				}
			}
		}
	}
	*l=pom;
	return rezultat;
}

int dubina(struct stablo *st)
{
	int dl=0,dd=0;
	if(st)
	{
		if(st->levi) dl=dubina(st->levi);
		if(st->desni) dd=dubina(st->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
	return 0;
}

void ispis(struct stablo *st)
{
	if(st)
	{
		ispis(st->levi);
		printf("string: %s\tbalans: %d\n",st->string,st->balans);
		ispis(st->desni);
	}
}

