#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct cvor{
	char *a;
	int balans;
	struct cvor *levi,*desni;
};

int dubina(struct cvor *koren){
	int dl,dd;
	dl=0;
	dd=0;
	if(koren){
		if(koren->levi) dl=dubina(koren->levi);
		if(koren->desni) dl=dubina(koren->desni);
		if(dl>dd) return ++dl;
		else	return ++dd;
	}
	else return 0;
}

void lrotacija(struct cvor **koren){
	struct cvor *x,*y;
	x=*koren;
	y=x->desni;
	
	x->desni=y->levi;
	y->levi=x;
	*koren=y;
	
	x->balans=dubina(x->desni)-dubina(x->levi);
	y->balans=dubina(y->desni)-dubina(y->levi);
}

void drotacija(struct cvor **koren){
	struct cvor *x,*y;
	y=*koren;
	x=y->levi;
	
	y->levi=x->desni;
	x->desni=y;
	*koren=x;
	
	x->balans=dubina(x->desni)-dubina(x->levi);
	y->balans=dubina(y->desni)-dubina(y->levi);
}

int dodaj(struct cvor **koren,struct cvor *z){
	struct cvor *t;
	int inkrement,rezultat;
	t=*koren;
	rezultat=0;
	
	if(t==NULL){
		t=z;
		rezultat=1;
	}
	else {	if(strcmp(z->a,t->a)>0) inkrement=dodaj(&(t->desni),z);
		else inkrement=-dodaj(&(t->levi),z);
	t->balans+=inkrement;
	if((inkrement!=0) && (t->balans!=0)){
		if(t->balans<-1){
			if(t->levi->balans<0) drotacija(&t);
			else { lrotacija(&(t->levi)); drotacija(&t); }
		}
		else {
		      if(t->balans>1){
			if(t->desni->balans>0) lrotacija(&t);
			else { drotacija(&(t->desni)); lrotacija(&t); }
			}
			else rezultat=1;
		}
	}
	}
	*koren=t;
	return(rezultat);
}

struct cvor *nadji(struct cvor *koren,char *s,struct cvor **r){
	struct cvor *t;
	t=koren;
	*r=NULL;
	
	while((t!=NULL) && (strcmp(t->a,s)!=0))
	{
		if(strcmp(s,t->a)<0) { *r=t; t=t->levi; }
		else { *r=t; t=t->desni; }
	}
	return t;
}

struct cvor *brisi(struct cvor *koren,char *s){
	struct cvor *t,*r,*q;
	t=nadji(koren,s,&r);
	
	if(t==NULL) {
		printf("Cvor ne postoji ili je stablo prazno.\n");
		return NULL;
	}
	
	if(!(t->levi) && !(t->desni)) q=NULL;
	if((t->levi) && !(t->desni)) q=t->levi;
	if(!(t->levi) && (t->desni)) q=t->desni;
	if((t->levi) && (t->desni)){
		q=t->desni;
		while(q->levi) q=q->levi;
		q->levi=t->levi;
		q=t->desni;
	}
	
	if(r!=NULL){
		if(t==r->levi) r->levi=q;
		else r->desni=q;
	}
	else koren=q;
	t=NULL;
	return(koren);
}

void ispis(struct cvor *koren){
	if(koren){
		ispis(koren->levi);
		printf("%s  bal: %d  ",koren->a,koren->balans);
		ispis(koren->desni);
	}
}

int dubinapod(struct cvor *koren,char *s){
	struct cvor *t,*r;
	int d;
	t=nadji(koren,s,&r);
	if(t==NULL) {exit(0);}
	printf("\nPronadjeno : %s\n",t->a);
	
	d=dubina(t);
	return d;
}		

main(){
	struct cvor *koren=NULL;
	struct cvor *z;
	int i,n,g;
	char s[20];
	char *f;
	printf("Unesite broj stringova : ");
	scanf("%d",&n);
	printf("Unesite stringove : \n");
	for(i=0;i<n;++i){
		scanf("%s",s);
		z=(struct cvor *)malloc(sizeof(struct cvor));
		z->a=(char *)malloc(strlen(s)+1);
		strcpy(z->a,s);
		z->balans=0;
		z->levi=z->desni=NULL;
		g=dodaj(&koren,z);
	}
	putchar('\n');
	ispis(koren);
	putchar('\n');
	printf("Koren : %s, dubina %d\n",koren->a,dubina(koren));
	printf("Unesite string za brisanje : ");
	scanf("%s",s);
	koren=brisi(koren,s);
	ispis(koren);
	putchar('\n');
	
	printf("Unesite string koji ce biti koren podstabla ciju dubinu odredjujete : ");
	scanf("%s",s);
	printf("Dubina trazenog podstabla je %d.\n",dubinapod(koren,s));
}




		
	
	
