#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct namestaj{
   char *naziv;
   int sifra,br_komada;
   float cena;
};
struct lista{
   struct namestaj *glava;
   struct lista *rep;
};

#define novi(x) x=(struct lista*)malloc(sizeof(struct lista))


void dodaj_sort(struct lista **p,struct namestaj *q){
   struct lista *temp,*res,*pos;
   novi(temp);
   if (!temp){
      printf("Greska pri alokaciji memorije\n");
      exit(0);
   }
   temp->glava=q;
   temp->rep=NULL;
   res=*p;
   if(!res) res=temp;

   else{
      if (res->glava->cena<q->cena){
         temp->rep=res;
         res=temp;
      }
      else {
         pos=res;
         while((pos->rep) &&
                (pos->rep->glava->cena>q->cena)) 
            pos=pos->rep;
         temp->rep=pos->rep;
         pos->rep=temp;
      }
   }
   *p=res;
}

struct namestaj* ucitaj_artikal(){
    struct namestaj *st;
    char s[100];
    getchar();
    st=(struct namestaj*)malloc(sizeof(struct namestaj));
    printf("Naziv: "); scanf("%s",s);
    st->naziv=(char*)malloc(strlen(s)+1);
    strcpy(st->naziv,s);
    
  printf("Unesi sifru \n"); scanf("%d",&st->sifra);
  printf("Unesi stanje \n"); scanf("%d",&st->br_komada);
  printf("Unesi Cenu \n"); scanf("%f",&st->cena);
  
	
 return st;
}


struct lista *form_sort(){
   int i,n;
   struct lista *p;
   struct namestaj *q;
   p=NULL;
   scanf("%d",&n);
   for(i=0;i<n;i++){
      q=ucitaj_artikal();
      printf("Ubaceno\n");
      dodaj_sort(&p,q);
   }
   return p;
}

void ispis(struct lista *p){
  while(p) {
     printf("%s ",p->glava->naziv);
     printf("%d ",p->glava->sifra);
     printf("%d %f\n",p->glava->br_komada,p->glava->cena);
     p=p->rep;
  }
}
 void brisi(struct lista **p, char x[50]){
	struct lista *res=*p, *pos=res, *temp;
	while(pos && (strcmp(pos->glava->naziv,x)==0)){
		temp=pos;
		res=pos->rep;
		free(pos);
		pos=res;
	}
	
	while(pos && pos->rep)
		if(strcmp(pos->rep->glava->naziv,x)==0){
			temp=pos->rep;
			pos->rep=temp->rep;
			free(temp);
		}
		else pos=pos->rep;
	
	*p=res;
}

int zbir(struct lista *p, float k){
int s;
s=0;
while(p) {
    if (p->glava->cena>k) s=s+p->glava->br_komada;
     p=p->rep;
  }
return s;
}


main(){
   struct lista *p;
   char a[50];
   float c;
  p=form_sort();
   ispis(p);
	
  printf("Unesi naziv artikla koji se brise \n");
  scanf("%s",a);
 brisi(&p,a);
ispis(p);
printf("Unesi cenu za BR artikala \n");
scanf("%f",&c);
printf("Na stanju je   %d",zbir(p,c));
printf("   Artikala\n");


  
}
